## ocsigenserver 2.6

=== Makefile ===
include Makefile.config

### Building

.PHONY: all byte opt doc

all:
	${MAKE} -C src all

byte:
	${MAKE} -C src byte

opt:
	${MAKE} -C src opt

doc:
	$(MAKE) -C doc

### Testing and debugging : local execution and toplevel ###

.PHONY: run.local run.opt.local top

run.local: byte
	CAML_LD_LIBRARY_PATH=src/server:$(CAML_LD_LIBRARY_PATH) src/server/${PROJECTNAME} -c local/etc/${PROJECTNAME}.conf

run.opt.local: opt
	CAML_LD_LIBRARY_PATH=src/server:$(CAML_LD_LIBRARY_PATH) src/server/${PROJECTNAME}.opt -c local/etc/${PROJECTNAME}.conf

top:
	cd src/server && ${MAKE} top

### Cleaning ###

clean: clean.local
	${MAKE} -C src clean

clean.local:
	-rm -f $(PROJECTNAME)-*.tar.gz

distclean: clean.local
	${MAKE} -C src distclean
	-make -C doc clean
	-rm Makefile.config
	-rm -f *~ \#* .\#*

### Installation ####

.PHONY: install partialinstall reinstall uninstall purge.files install.files

install.META:
	$(MAKE) -C src install
install.META.byte:
	$(MAKE) -C src install.byte
install.META.opt:
	$(MAKE) -C src install.opt

reinstall: uninstall install
reinstall.byte: uninstall install.byte
reinstall.opt: uninstall install.opt

install: install.META install.files
	@echo
	@echo "## Run \"make doc\" and \"make install.doc\" to build and install the ocamldoc."

install.byte: install.META.byte install.files
install.opt: install.META.opt install.files

# BB If install is not run by root but OCSIGENUSER, OCSIGENGROUP is somebody
# BB different, make files universally accessible, we cannot chown.
INSTALL_CAN_PUT_PERMISSIONS=yes
INSTALL_USER_GROUP=-o $(OCSIGENUSER) -g $(OCSIGENGROUP)
INSTALL_MOD_660=660
INSTALL_MOD_644=644
INSTALL_MOD_755=755
INSTALL_MOD_770=770
INSTALL_MOD_750=750
ifneq ($(shell id -u), 0)
  ifneq ($(OCSIGENUSER), $(USERNAME))
    INSTALL_CAN_PUT_PERMISSIONS=no
  endif
  ifneq ($(shell groups ${USERNAME}|grep -q ${OCSIGENGROUP}; echo $$?), 0)
    INSTALL_CAN_PUT_PERMISSIONS=no
  endif
endif
ifeq ($(INSTALL_CAN_PUT_PERMISSIONS), no)
    INSTALL_USER_GROUP=
    INSTALL_MOD_660=666
    INSTALL_MOD_644=666
    INSTALL_MOD_755=777
    INSTALL_MOD_770=777
    INSTALL_MOD_750=777
endif

install.files:
	@echo INSTALL_CAN_PUT_PERMISSIONS: ${INSTALL_CAN_PUT_PERMISSIONS}
	 ## Command pipe
	$(INSTALL) -m ${INSTALL_MOD_755} -d $(dir $(TEMPROOT)$(COMMANDPIPE))
	[ -p $(TEMPROOT)$(COMMANDPIPE) ] || \
	 { mkfifo -m ${INSTALL_MOD_660} $(TEMPROOT)$(COMMANDPIPE); \
	   if [ "${INSTALL_CAN_PUT_PERMISSIONS}" = yes ]; \
	     then $(CHOWN) -R $(OCSIGENUSER):$(OCSIGENGROUP) $(TEMPROOT)$(COMMANDPIPE); \
	   fi; }
	 ## Configuration files
	$(INSTALL) -m ${INSTALL_MOD_755} -d $(TEMPROOT)$(CONFIGDIR)/conf.d
	${INSTALL} -m ${INSTALL_MOD_644} ${PROJECTNAME}.conf.sample $(TEMPROOT)$(CONFIGDIR)/
	[ -f $(TEMPROOT)$(CONFIGDIR)/$(PROJECTNAME).conf ] || \
	  { $(INSTALL) -m ${INSTALL_MOD_644} $(PROJECTNAME).conf.sample \
                $(TEMPROOT)$(CONFIGDIR)/$(PROJECTNAME).conf;  }
	-mv $(TEMPROOT)$(CONFIGDIR)/mime.types $(TEMPROOT)$(CONFIGDIR)/mime.types.old
	 ## Log directory
	$(INSTALL) -m ${INSTALL_MOD_644} src/files/mime.types $(TEMPROOT)$(CONFIGDIR)
	$(INSTALL) -d -m ${INSTALL_MOD_755} ${INSTALL_USER_GROUP} $(TEMPROOT)$(LOGDIR)
	 ## Static files
	$(INSTALL) -d -m ${INSTALL_MOD_755} ${INSTALL_USER_GROUP} $(TEMPROOT)$(STATICPAGESDIR)
	$(INSTALL) -d -m ${INSTALL_MOD_750} ${INSTALL_USER_GROUP} $(TEMPROOT)$(DATADIR)
	$(INSTALL) -m ${INSTALL_MOD_644} ${INSTALL_USER_GROUP} \
	  local/var/www/*.html $(TEMPROOT)$(STATICPAGESDIR)
	$(INSTALL) -d -m ${INSTALL_MOD_755} ${INSTALL_USER_GROUP} \
	  $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
	$(INSTALL) -m ${INSTALL_MOD_644} ${INSTALL_USER_GROUP} \
	  local/var/www/ocsigenstuff/*.png local/var/www/ocsigenstuff/*.css \
	  $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
	$(INSTALL) -d -m ${INSTALL_MOD_755} $(TEMPROOT)$(MANDIR)
	$(INSTALL) -m ${INSTALL_MOD_644} src/files/${PROJECTNAME}.1 $(TEMPROOT)$(MANDIR)

uninstall:
	-make -C doc uninstall
	-rm -f $(TEMPROOT)$(CONFIGDIR)/$(PROJECTNAME).conf.sample
	-rm -f $(TEMPROOT)$(MANDIR)/${PROJECTNAME}.1
	-rm -f $(TEMPROOT)$(COMMANDPIPE)
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(CONFIGDIR)/conf.d
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(CONFIGDIR)
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(LOGDIR)
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(DATADIR)
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(MANDIR)
	-$(MAKE) -C src uninstall

purge: purge.files uninstall

purge.files:
	-rm -f $(TEMPROOT)$(CONFIGDIR)/mime.types $(TEMPROOT)$(CONFIGDIR)/mime.types.old
	-rm -f $(TEMPROOT)$(CONFIGDIR)/$(PROJECTNAME).conf
	-rm -f $(patsubst local/var/www/ocsigenstuff/%, \
	 		  $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff/%, \
	                  $(wildcard local/var/www/ocsigenstuff/*))
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
	-rm -f $(patsubst local/var/www/%, \
	 		  $(TEMPROOT)$(STATICPAGESDIR)/%, \
	                  $(wildcard local/var/www/*.html))
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(STATICPAGESDIR)

install.doc:
	${MAKE} -C doc install

### Install logrotate configuration files ###

.PHONY: logrotate

logrotate:
	 $(INSTALL) -m 755 -d $(TEMPROOT)/etc/logrotate.d
	 cat src/files/logrotate.in \
	     | sed s%LOGDIR%$(LOGDIR)%g \
	     | sed s%USER%$(OCSIGENUSER)%g \
	     | sed s%GROUP%$(OCSIGENGROUP)%g \
	     | sed s%_COMMANDPIPE_%$(COMMANDPIPE)%g \
	     > $(TEMPROOT)/etc/logrotate.d/$(PROJECTNAME)

###

.PHONY: depend
depend:
	${MAKE} -C src depend

=== doc/Makefile ===
include ../Makefile.config
include ../src/Makefile.filelist

OCAMLDOC := ${OCAMLFIND} ocamldoc
ODOC_WIKI := odoc_wiki.cma

LIBS := -package lwt,tyxml,ssl,netstring,netstring-pcre,ipaddr \
        ${addprefix -I ../src/, baselib http server extensions }

doc: api-html/index.html
api-html/index.html: indexdoc $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))
	mkdir -p api-html
	$(OCAMLDOC) ${LIBS} -d api-html -intro indexdoc -html $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))

wikidoc: api-wiki/index.wiki
api-wiki/index.wiki: indexdoc $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))
	mkdir -p api-wiki
	$(OCAMLDOC) ${LIBS} -d api-wiki -intro indexdoc -colorize-code \
	   -i $(shell ocamlfind query wikidoc) -g ${ODOC_WIKI} \
	   $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))

install:
	${INSTALL} -d -m 755 $(TEMPROOT)$(DOCDIR)
	$(INSTALL) -m 644 api-html/* $(TEMPROOT)$(DOCDIR)

uninstall:
	-rm -Rf $(TEMPROOT)$(DOCDIR)

clean:
	-rm -f api-html/* api-wiki/*
	-rm -f *~ \#* .\#*

=== src/Makefile ===
include ../Makefile.config

all: metas confs
	${MAKE} -C baselib all
	${MAKE} -C http all
	${MAKE} -C server all
	${MAKE} -C extensions all

byte: metas confs
	${MAKE} -C baselib byte
	${MAKE} -C http byte
	${MAKE} -C server byte
	${MAKE} -C extensions byte

opt: metas confs
	${MAKE} -C baselib opt
	${MAKE} -C http opt
	${MAKE} -C server opt
	${MAKE} -C extensions opt

### META ###

metas: files/META files/META.${PROJECTNAME}

files/META: files/META.in ../Makefile.config ../Makefile.options Makefile
	cat $< \
	  | sed s/%%CAMLZIPNAME%%/$(CAMLZIPNAME)/ \
	  | sed s/%%NAME%%/$(PROJECTNAME)/g \
	  | sed s/%%DEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${SERVER_PACKAGE})/g \
	  | sed s/%%BASEDEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${BASE_PACKAGE})/g \
	  > $@

files/META.${PROJECTNAME}: files/META.in ../Makefile.config ../Makefile.options Makefile
	echo directory = \"../server\" > $@
	cat $< \
	  | sed s/%%CAMLZIPNAME%%/$(CAMLZIPNAME)/ \
	  | sed s/%%NAME%%/$(PROJECTNAME)/g \
	  | sed s/%%DEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${SERVER_PACKAGE})/g \
	  | sed s/%%BASEDEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${BASE_PACKAGE})/g \
	  | sed "s%package \"\(polytables\|commandline\|baselib\)\" (%package \"\1\" (\n  directory = \"../baselib\"%" \
	  | sed "s%package \"\(http\|cookies\)\" (%package \"\1\" (\n  directory = \"../http\"%" \
	  | sed "s%directory = \"extensions\"%directory = \"../extensions\"%" \
	  >> $@

### CONF ####

confs: ../$(PROJECTNAME).conf.sample ../local/etc/${PROJECTNAME}.conf

../$(PROJECTNAME).conf.sample: files/$(PROJECTNAME).conf.in ../Makefile.config Makefile
	cat $< \
	  | sed s%_LOGDIR_%$(LOGDIR)%g \
	  | sed s%_DATADIR_%$(DATADIR)%g \
	  | sed s%_OCSIGENUSER_%$(OCSIGENUSER)%g \
	  | sed s%_OCSIGENGROUP_%$(OCSIGENGROUP)%g \
	  | sed s%_COMMANDPIPE_%$(COMMANDPIPE)%g \
	  | sed s%_MIMEFILE_%$(CONFIGDIR)/mime.types%g \
	  | sed s%_METADIR_%$(LIBDIR)%g \
	  | sed s%_PROJECTNAME_%$(PROJECTNAME)%g \
	  | sed s%_LIBDIR_%$(LIBDIR)%g \
	  | sed s%_EXTDIR_%$(LIBDIR)/ocsigenserver/extensions%g \
	  | sed s%_CONFIGDIR_%$(CONFIGDIR)%g \
	  | sed s%_STATICPAGESDIR_%$(STATICPAGESDIR)%g \
	  | sed s%_EXTPACKAGENAME_%$(PROJECTNAME).ext%g \
	  > $@

../local/etc/$(PROJECTNAME).conf: files/${PROJECTNAME}.conf.in ../Makefile.config Makefile
	mkdir -p ../local/etc ../local/var/log ../local/var/run
	cat $< \
	  | sed s%80\</port\>%8080\</port\>%g \
	  | sed s%_LOGDIR_%$(SRC)/local/var/log%g \
	  | sed s%_DATADIR_%$(SRC)/local/var/lib%g \
	  | sed s%\<user\>_OCSIGENUSER_\</user\>%%g \
	  | sed s%\<group\>_OCSIGENGROUP_\</group\>%%g \
	  | sed s%_COMMANDPIPE_%$(SRC)/local/var/run/${PROJECTNAME}_command%g \
	  | sed s%_MIMEFILE_%$(SRC)/src/files/mime.types%g \
	  | sed s%_METADIR_%${LIBDIR}\"/\>\<findlib\ path=\"$(SRC)/src/files/\"/\>\<findlib\ path=\"$(SRC)/src/extensions/files/%g \
	  | sed s%_PROJECTNAME_%$(PROJECTNAME)%g \
	  | sed s%_EXTLIBDIR_%${SRC}/src/extensions/ocsipersist-dbm%g \
	  | sed s%_CONFIGDIR_%$(SRC)/local/etc%g \
	  | sed s%_STATICPAGESDIR_%$(SRC)/local/var/www%g \
	  | sed s%_EXTPACKAGENAME_%$(PROJECTNAME).ext%g \
	  | sed s%\<\!--\ \<commandpipe%\<commandpipe%g \
	  | sed s%\</commandpipe\>\ --\>%\</commandpipe\>%g \
	  | sed s%\<\!--\ \<mimefile%\<mimefile%g \
	  | sed s%\</mimefile\>\ --\>%\</mimefile\>%g \
	  | sed s%store\ dir=\"$(SRC)/var/lib\"%store\ dir=\"$(SRC)/local/var/lib/ocsipersist\"%g \
	  > $@


### Install ###

include Makefile.filelist

VERSION := $(shell head -n 1 ../VERSION)

install: INSTALL_BIN=$(BIN) $(NATBIN)
install: INSTALL_IMPL=$(IMPL) $(NATIMPL)
install: INSTALL_PLUGINS_IMPL=$(PLUGINS_IMPL) $(PLUGINS_NATIMPL)
install: INSTALL_PLUGINS_BIN=$(PLUGINS_BIN) $(PLUGINS_NATBIN)
install: raw_install

install.byte: INSTALL_BIN=$(BIN)
install.byte: INSTALL_IMPL=$(IMPL)
install.byte: INSTALL_PLUGINS_IMPL=$(PLUGINS_IMPL)
install.byte: INSTALL_PLUGINS_BIN=$(PLUGINS_BIN)
install.byte: raw_install

install.opt: INSTALL_BIN=$(NATBIN)
install.opt: INSTALL_IMPL=$(NATIMPL)
install.opt: INSTALL_PLUGINS_IMPL=$(PLUGINS_NATIMPL)
install.opt: INSTALL_PLUGINS_BIN=$(PLUGINS_NATBIN)
install.opt: raw_install

raw_install:
	 # Server binaries
	$(INSTALL) -m 755 -d $(TEMPROOT)$(BINDIR)
	$(INSTALL) -m 755 $(INSTALL_BIN) $(TEMPROOT)$(BINDIR)/
	 # Server libraries
	$(INSTALL) -m 755 -d $(TEMPROOT)$(LIBDIR)
	$(OCAMLFIND) install $(PROJECTNAME) \
	   -destdir $(TEMPROOT)$(LIBDIR) \
	   -patch-version ${VERSION} \
	   ${INTF} $(INSTALL_IMPL) $(DOC) files/META
	 # Extensions
	$(INSTALL) -m 755 -d $(TEMPROOT)${LIBDIR}/${PROJECTNAME}/extensions/
	$(INSTALL) -m 644 \
	  $(PLUGINS_INTF) $(INSTALL_PLUGINS_IMPL) $(PLUGINS_DOC) \
	  $(TEMPROOT)${LIBDIR}/${PROJECTNAME}/extensions/
	[ -z "$(strip ${INSTALL_PLUGINS_BIN})" ] || \
	  $(INSTALL) -m 755 $(INSTALL_PLUGINS_BIN) \
	  $(TEMPROOT)${LIBDIR}/${PROJECTNAME}/extensions/

uninstall:
	 # Extensions
	-rm -r $(TEMPROOT)${LIBDIR}/${PROJECTNAME}/extensions/
	 # Server libraries
	-$(OCAMLFIND) remove ${PROJECTNAME} -destdir $(TEMPROOT)${LIBDIR}
	 # Server binaries
	-rm -r $(addprefix $(TEMPROOT)$(BINDIR)/,$(notdir ${BIN} ${NATBIN}))
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(BINDIR)

reinstall: uninstall install

###

clean: clean.local
	${MAKE} -C baselib clean
	${MAKE} -C http clean
	${MAKE} -C server clean
	${MAKE} -C extensions clean

clean.local:
	-rm -f ../${PROJECTNAME}.conf.sample
	-rm -f ../${PROJECTNAME}.conf.opt.sample
	-rm -f ../${PROJECTNAME}.conf.local
	-rm -f ../${PROJECTNAME}.conf.opt.local
	-rm -f files/META files/META.${PROJECTNAME}

distclean: clean.local
	${MAKE} -C baselib distclean
	${MAKE} -C http distclean
	${MAKE} -C server distclean
	${MAKE} -C extensions distclean
	-rm -f *~ \#* .\#*
	-cd files; rm -f *~ \#* .\#*
	-rm -fr ../local/var/log/*.log
	-rm -fr ../local/var/lib/ocsidb
	-rm -fr ../local/etc/${PROJECTNAME}.conf
	-rm -fr ../local/etc/${PROJECTNAME}.conf.opt

depend:
	${MAKE} -C baselib depend
	${MAKE} -C http depend
	${MAKE} -C server depend
	${MAKE} -C extensions depend

=== src/baselib/Makefile ===
include ../../Makefile.config

PACKAGE  := \
	bytes \
	lwt.unix \
	netstring \
	netstring-pcre \
	cryptokit \
	findlib \
	tyxml \
	lwt.syntax \
	${LWT_PREEMPTIVE_PACKAGE} \
	ipaddr \
	${SERVER_SYNTAX} ## See ../../Makefile.options
LIBS     := ${addprefix -package ,${PACKAGE}}
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte opt

### Common files ###

FILES := ocsigen_lib_base.ml       \
	 ocsigen_lib.ml            \
	 ocsigen_cache.ml          \
         ocsigen_config.ml         \
	 ocsigen_commandline.ml    \
	 ocsigen_messages.ml       \
	 dynlink_wrapper.ml        \
         ocsigen_loader.ml         \
	 ocsigen_stream.ml         \

INTF_NOP4 := ocsigen_lib_base.mli ocsigen_lib.mli

PREDEP := ocsigen_config.ml dynlink_wrapper.ml

byte:: baselib.cma
opt:: baselib.cmxa

baselib.cma:
	${OCAMLC} -a -o $@ $^
baselib.cmxa: $(FILES:.ml=.cmx)
	${OCAMLOPT} -a -o $@ $^

baselib.cma: $(FILES:.ml=.cmo)

## Ocsigen_config ##

ifeq "$(NATDYNLINK)" "YES"
  NATIVECODE_RUNTIME_DETECT=Dynlink.is_native
else
  NATIVECODE_RUNTIME_DETECT=false
endif

ifeq "$(PREEMPTIVE)" "YES"
  PREEMTIMPLEM=Lwt_preemptive
else
  PREEMTIMPLEM=Fake_preempt
endif

VERSION := $(shell head -n 1 ../../VERSION)

ocsigen_config.ml: ocsigen_config.ml.in ../../Makefile.config ../../Makefile.options ../../VERSION
	cat ocsigen_config.ml.in \
	| sed s%0000000000000000%${VERSION}% \
	| sed s%_WARNING_%"Warning: this file has been generated from ocsigen_config.ml.in - DO NOT MODIFY MANUALLY!"% \
	| sed s%_LOGDIR_%$(LOGDIR)% \
	| sed s%_DATADIR_%$(DATADIR)%g \
	| sed s%_BINDIR_%$(BINDIR)%g \
	| sed s%_EXTDIR_%$(LIBDIR)/${PROJECTNAME}/extensions%g \
	| sed s%_STATICPAGESDIR_%$(STATICPAGESDIR)% \
	| sed s%_UP_%$(UPLOADDIR)%g \
	| sed s%_OCSIGENUSER_%$(OCSIGENUSER)%g \
	| sed s%_OCSIGENGROUP_%$(OCSIGENGROUP)%g \
	| sed s%_PROJECTNAME_%$(PROJECTNAME)%g \
	| sed s%_COMMANDPIPE_%$(COMMANDPIPE)%g \
	| sed s%_CONFIGDIR_%$(CONFIGDIR)% \
	| sed s%_PREEMTIMPLEM_%$(PREEMTIMPLEM)% \
	| sed s%_ISNATIVE_%$(NATIVECODE_RUNTIME_DETECT)%g \
	| sed "s%_DEPS_%$(INITPACKAGE)%g" \
	> ocsigen_config.ml

## Dynlink_wrapper ##

ifeq "$(NATDYNLINK)" "YES"
dynlink_wrapper.ml:
	ln -s dynlink_wrapper.natdynlink.ml $@
dynlink_wrapper.cmo dynlink_wrapper.cmx: dynlink_wrapper.natdynlink.ml
else
dynlink_wrapper.ml:
	ln -s dynlink_wrapper.nonatdynlink.ml $@
dynlink_wrapper.cmo dynlink_wrapper.cmx: dynlink_wrapper.nonatdynlink.ml
endif

### Command line ###

byte:: parsecommandline.cma donotparsecommandline.cma
opt:: parsecommandline.cmxa donotparsecommandline.cmxa
ifeq "$(NATDYNLINK)" "YES"
opt:: parsecommandline.cmxs donotparsecommandline.cmxs
endif

parsecommandline.cma: commandline/ocsigen_getcommandline.cmo
	$(OCAMLC) -a -o $@ $^

donotparsecommandline.cma: nocommandline/ocsigen_getcommandline.cmo
	$(OCAMLC) -a -o $@ $^

parsecommandline.cmxa: commandline/ocsigen_getcommandline.cmx
	$(OCAMLOPT) -a -o $@ $^

donotparsecommandline.cmxa: nocommandline/ocsigen_getcommandline.cmx
	$(OCAMLOPT) -a -o $@ $^

### Polytables ###

byte:: polytables.cma
opt:: polytables.cmxa
ifeq "$(NATDYNLINK)" "YES"
opt:: polytables.cmxs
endif

polytables.cma: polytables.cmo
	$(OCAMLC) -a -o $@ $<

polytables.cmxa: polytables.cmx
	$(OCAMLOPT) -a -o $@ $<

##########

%.cmi: %.mli
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
${INTF_NOP4:.mli=.cmi}: \
%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) -syntax camlp4o ${LIBS} -c $<
%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<

## Clean up

clean:
	-rm -f *.cm* *.o *.a *.annot
	-rm -f ${PREDEP}
	-cd commandline; rm -f *.cm* *.annot *.o
	-cd nocommandline; rm -f *.cm* *.annot *.o

distclean: clean
	-rm -f *~ \#* .\#*

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} -syntax camlp4o $(filter-out ${INTF_NOP4},$(wildcard *.mli)) *.ml > .depend
	$(OCAMLDEP) ${LIBS} ${INTF_NOP4} >> .depend

FORCE:
-include .depend

=== src/extensions/Makefile ===
include ../../Makefile.config

PACKAGE  :=		\
	bytes		\
	lwt.unix	\
	ipaddr		\
	lwt.ssl		\
	lwt.react	\
	netstring	\
	netstring-pcre	\
	tyxml.parser	\
	${SERVER_SYNTAX} ## See ../../Makefile.options

LIBS     := -I ../baselib -I ../http -I ../server ${addprefix -package ,${PACKAGE}}
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte opt

### Extensions ###

FILES := staticmod.ml           \
	 cgimod.ml              \
	 redirectmod.ml         \
	 revproxy.ml            \
	 extensiontemplate.ml   \
         accesscontrol.ml       \
         userconf.ml            \
	 outputfilter.ml        \
	 authbasic.ml           \
	 rewritemod.ml          \
	 extendconfiguration.ml \
         ocsigen_comet.ml       \
         cors.ml                \

ifeq "$(CAMLZIP)" "YES"
FILES += deflatemod.ml
deflatemod.cmo deflatemod.cmx: LIBS+=-package ${CAMLZIPNAME}
endif

byte:: ${FILES:.ml=.cmo}
opt:: ${FILES:.ml=.cmx}
ifeq "$(NATDYNLINK)" "YES"
opt:: ${FILES:.ml=.cmxs}
endif

### SQLite ###

ifeq "$(OCSIPERSISTSQLITE)" "YES"
byte::
	$(MAKE) -C ocsipersist-sqlite byte
opt::
	$(MAKE) -C ocsipersist-sqlite opt
endif

### DBM ####

ifeq "$(OCSIPERSISTDBM)" "YES"
byte::
	$(MAKE) -C ocsipersist-dbm byte
opt::
	$(MAKE) -C ocsipersist-dbm opt
endif

##########

%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) ${LIBS} -c $<
%.cmxs: %.cmx
	$(OCAMLOPT) -shared -linkall -o $@ $<

## Clean up

clean: clean.local
	${MAKE} -C ocsipersist-dbm clean
	${MAKE} -C ocsipersist-sqlite clean
clean.local:
	-rm -f *.cm* *.o *.a *.annot
	-rm -f ${PREDEP}
distclean: clean.local
	-rm -f *~ \#* .\#*
	${MAKE} -C ocsipersist-dbm distclean
	${MAKE} -C ocsipersist-sqlite distclean

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} *.mli *.ml > .depend
	${MAKE} -C ocsipersist-dbm depend
	${MAKE} -C ocsipersist-sqlite depend

FORCE:
-include .depend

=== src/http/Makefile ===
include ../../Makefile.config
PACKAGE  := \
	bytes \
	netstring \
	netstring-pcre \
	lwt.ssl \
	tyxml \
	${SERVER_SYNTAX} ## See ../../Makefile.options

LIBS     := -I ../baselib ${addprefix -package ,${PACKAGE}}
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte opt

### Common files ###

FILES := multipart.ml            \
	 http_headers.ml         \
	 ocsigen_cookies.ml      \
         ocsigen_http_frame.ml   \
	 ocsigen_headers.ml      \
	 http_lexer.ml	         \
         framepp.ml              \
	 ocsigen_http_com.ml     \
	 ocsigen_charset_mime.ml \
         ocsigen_senders.ml      \

PREDEP := http_lexer.ml   \

byte: http.cma
opt: http.cmxa

http.cma: $(FILES:.ml=.cmo)
	${OCAMLC} -a -o $@ $^
http.cmxa: $(FILES:.ml=.cmx)
	${OCAMLOPT} -a -o $@ $^

##########

%.ml: %.mll
	$(OCAMLLEX) $<
%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) ${LIBS} -c $<
%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<

## Clean up

clean:
	-rm -f *.cm* *.o *.a *.annot
	-rm -f ${PREDEP}
distclean: clean
	-rm -f *~ \#* .\#*

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} *.mli *.ml > .depend

type: $(FILES:.ml=.gmli)

%.gmli: %.ml
	$(OCAMLC) ${LIBS} -i $< > $@

FORCE:
-include .depend

=== src/server/Makefile ===
include ../../Makefile.config

all: byte opt

PACKAGE  := ${SERVER_PACKAGE} ${SERVER_SYNTAX} ## See ../../Makefile.options
LIBS     := -I ../baselib -I ../http ${addprefix -package ,${PACKAGE}} -I .
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte opt

### Common files ###

FILES := ocsigen_socket.ml      \
         ocsigen_request_info.ml \
         ocsigen_command.ml     \
         ocsigen_range.ml       \
         ocsigen_extensions.ml  \
         ocsigen_parseconfig.ml \
         ocsigen_http_client.ml \
         ocsigen_local_files.ml \
         ocsigen_server.ml      \


byte:: ${PROJECTNAME}.cma
opt:: ${PROJECTNAME}.cmxa

${PROJECTNAME}.cma: $(FILES:.ml=.cmo)
	${OCAMLC} -a -o $@ $^
${PROJECTNAME}.cmxa: $(FILES:.ml=.cmx)
	${OCAMLOPT} -a -o $@ $^

### Server ###

byte:: ${PROJECTNAME}
opt:: ${PROJECTNAME}.opt

ifdef DONOTPARSECOMMANDLINE
PARSECOMMANDLINE := ../baselib/donotparsecommandline.cma
else
PARSECOMMANDLINE := ../baselib/parsecommandline.cma
endif

SERVERLIBS := ${PARSECOMMANDLINE}       \
              ../baselib/baselib.cma    \
	      ../baselib/polytables.cma \
	      ../http/http.cma          \
	      ${PROJECTNAME}.cma         \

SERVEROBJS := server_main.cmo

${PROJECTNAME}: ${SERVERLIBS} ${SERVEROBJS}
	${OCAMLC} -o $@ -linkpkg -linkall ${THREAD} ${LIBS} $^
${PROJECTNAME}.opt: ${SERVERLIBS:.cma=.cmxa} ${SERVEROBJS:.cmo=.cmx}
	${OCAMLOPT} -o $@ -linkpkg -linkall ${THREAD} ${LIBS} $^

### Toplevel ####

top: servertop
	OCAMLPATH=${SRC}/src/files/:${OCAMLPATH} ${RLWRAP} ./servertop

servertop: ${SERVERLIBS}
	OCAMLPATH=${SRC}/src/files/:${OCAMLPATH} ${OCAMLFIND} ocamlmktop \
	   -o $@ -linkall -linkpkg ${THREAD} ${LIBS} $^

##########

%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) ${LIBS} -c $<
%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<
%.o: %.c
	$(OCAMLC) -c $<

## Clean up

clean:
	-rm -f *.cm* *.o *.a *.annot
	-rm -f ${PREDEP}
	-rm -f ${PROJECTNAME} ${PROJECTNAME}.opt
	-rm -f servertop
distclean: clean
	-rm -f *~ \#* .\#*

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} *.mli *.ml > .depend

FORCE:
-include .depend

=== src/extensions/ocsipersist-dbm/Makefile ===
include ../../../Makefile.config

PACKAGE  := ${LWT_PREEMPTIVE_PACKAGE} \
	    lwt.unix     \
	    tyxml.parser \
	    dbm          \

LIBS     := -I ../../baselib -I ../../http -I ../../server \
	    ${addprefix -package ,${PACKAGE}}
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte opt

###

byte:: ocsipersist-dbm.cma
opt:: ocsipersist-dbm.cmxa
ifeq "$(NATDYNLINK)" "YES"
opt:: ocsipersist-dbm.cmxs
endif

PREDEP := ocsipersist.mli

ocsipersist-dbm.cma: ocsipersist.cmo
	$(OCAMLC) -a -o $@ $^
	cp ocsipersist.cmi ..
	cp $@ ..

ocsipersist-dbm.cmxa: ocsipersist.cmx
	$(OCAMLOPT) -a -o $@ $^
	cp ocsipersist.cmi ..
	cp $@ ${patsubst %.cmxa,%.a,$@} ..

ocsipersist-dbm.cmxs: ocsipersist-dbm.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $^
	cp $@ ..

ocsipersist.mli:
	ln -s ../ocsipersist.mli .

###

byte:: ocsidbm
opt:: ocsidbm.opt

ocsidbm: ocsidbm.cmo
	$(OCAMLC) -linkpkg -o $@ ${LIBS} $^

ocsidbm.opt: ocsidbm.cmx
	$(OCAMLOPT) -linkpkg -o $@ ${LIBS} $^

##########

%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) ${LIBS} -c $<
%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f ${PREDEP}
	-rm -f ocsidbm ocsidbm.opt
distclean: clean
	-rm -f *~ \#* .\#*

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} *.mli *.ml > .depend

FORCE:
-include .depend

=== src/extensions/ocsipersist-sqlite/Makefile ===
include ../../../Makefile.config

PACKAGE  := lwt.preemptive  \
	    tyxml.parser \
	    sqlite3      \

LIBS     := -I ../../baselib -I ../../http -I ../../server \
	    ${addprefix -package ,${PACKAGE}}
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte opt

###

byte: ocsipersist-sqlite.cma
opt:: ocsipersist-sqlite.cmxa
ifeq "$(NATDYNLINK)" "YES"
opt:: ocsipersist-sqlite.cmxs
endif

PREDEP := ocsipersist.mli

ocsipersist-sqlite.cma: ocsipersist.cmo
	$(OCAMLC) -a -o $@ $^
	cp ocsipersist.cmi ..
	cp $@ ..

ocsipersist-sqlite.cmxa: ocsipersist.cmx
	$(OCAMLOPT) -a -o $@ $^
	cp ocsipersist.cmi ..
	cp $@ ${patsubst %.cmxa,%.a,$@} ..

ocsipersist-sqlite.cmxs: ocsipersist-sqlite.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $^
	cp $@ ..

ocsipersist.mli:
	ln -s ../ocsipersist.mli .

##########

%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) ${LIBS} -c $<
%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f ${PREDEP}
distclean: clean
	-rm -f *~ \#* .\#*

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} *.mli *.ml > .depend

FORCE:
-include .depend

=== debian/changelog ===
ocsigenserver (2.6-1build2) xenial; urgency=medium

  * Rebuild for new OCaml ABIs.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 12 Feb 2016 12:24:57 +0000

ocsigenserver (2.6-1build1) xenial; urgency=medium

  * Rebuild for new OCaml ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 06 Jan 2016 11:56:33 +0000

ocsigenserver (2.6-1) unstable; urgency=medium

  * Team upload.
  * New uptsream release
  * Add libfindlib-ocaml-dev to Build-Depends
  * Bump minimal requirement on Lwt to 2.5~
  * Build-Depend on camlp4 instead of camlp4-extra
  * Build-Depend on tyxml >= 3.5.0~
  * Install README.md instead of README file (which is gone)

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 18 Oct 2015 13:27:22 +0200

=== debian/control ===
Source: ocsigenserver
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>,
 Samuel Mimram <smimram@debian.org>,
 Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Build-Depends:
 debhelper (>= 8),
 ocaml-nox (>= 4.01),
 camlp4 (>= 4.02~),
 ocaml-findlib (>= 1.4),
 liblwt-ssl-ocaml-dev (>= 2.5~),
 libocamlnet-ocaml-dev (>= 3.6.5),
 libpcre-ocaml-dev (>= 6.0.1-2~),
 libssl-ocaml-dev (>= 0.4.3-3~),
 libsqlite3-ocaml-dev (>= 1.5.6-3~),
 libzip-ocaml-dev (>= 1.04-6~),
 libcryptokit-ocaml-dev (>= 1.3-14~),
 libtyxml-ocaml-dev (>= 3.5.0~),
 libfindlib-ocaml-dev,
 libipaddr-ocaml-dev,
 dh-ocaml (>= 0.9.5~)
Standards-Version: 3.9.4
Homepage: http://ocsigen.org/ocsigenserver/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocsigenserver.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocsigenserver.git

Package: ocsigenserver
Section: httpd
Architecture: any
Depends: adduser, psmisc, procps,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests: ocsigenserver-doc
Provides: httpd, httpd-cgi
Description: web server of the Ocsigen project
 The Ocsigen project is aimed at proposing clean and safe tools for
 developing and running client/server Web 2.0 applications.
 .
 Ocsigen Server is a full featured Web server. It implements most
 features of the HTTP protocol, and has a very powerful extension
 mechanism that make very easy to plug your own OCaml modules for
 generating pages. Many extensions are available, like a reverse
 proxy, content compression, access control, authentication, etc.

Package: libocsigenserver-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: web server of the Ocsigen project (runtime libraries)
 The Ocsigen project is aimed at proposing clean and safe tools for
 developing and running client/server Web 2.0 applications.
 .
 Ocsigen Server is a full featured Web server. It implements most
 features of the HTTP protocol, and has a very powerful extension
 mechanism that make very easy to plug your own OCaml modules for
 generating pages. Many extensions are available, like a reverse
 proxy, content compression, access control, authentication, etc.
 .
 This package contains runtime libraries.

Package: libocsigenserver-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 libgdbm-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocsigenserver-doc
Description: web server of the Ocsigen project (dev libraries)
 The Ocsigen project is aimed at proposing clean and safe tools for
 developing and running client/server Web 2.0 applications.
 .
 Ocsigen Server is a full featured Web server. It implements most
 features of the HTTP protocol, and has a very powerful extension
 mechanism that make very easy to plug your own OCaml modules for
 generating pages. Many extensions are available, like a reverse
 proxy, content compression, access control, authentication, etc.
 .
 This package contains development libraries.

Package: ocsigenserver-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Enhances: ocsigenserver, libocsigenserver-ocaml-dev
Description: web server of the Ocsigen project (documentation)
 The Ocsigen project is aimed at proposing clean and safe tools for
 developing and running client/server Web 2.0 applications.
 .
 Ocsigen Server is a full featured Web server. It implements most
 features of the HTTP protocol, and has a very powerful extension
 mechanism that make very easy to plug your own OCaml modules for
 generating pages. Many extensions are available, like a reverse
 proxy, content compression, access control, authentication, etc.
 .
 This package contains documentation: the manual (in wikicreole
 format) and the API reference generated by ocamldoc (in HTML format).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

DESTDIR := $(CURDIR)/debian/tmp

ifeq ($(OCAML_NATDYNLINK),yes)
  OPT_CONFFLAGS := --enable-natdynlink
else
  OPT_CONFFLAGS := --disable-natdynlink
endif

# This should test OCAML_HAVE_OCAMLOPT, but camlp4 usage seems to
# force dynlink...
ifeq ($(OCAML_NATDYNLINK),yes)
  BUILD_TARGET := all
  INSTALL_TARGET := install
else
  BUILD_TARGET := byte
  INSTALL_TARGET := install.byte
endif

BUILD_DOC := $(if $(findstring ocsigenserver-doc,$(shell dh_listpackages)),yes,no)

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	mkdir -p local/etc
	sh configure \
	    --temproot $(DESTDIR) \
	    --prefix /usr \
	    --bindir /usr/bin \
	    --libdir $(OCAML_STDLIB_DIR) \
	    --mandir /usr/share/man/man1 \
	    --docdir /usr/share/doc/ocsigenserver/api-html \
	    --staticpagesdir /usr/share/ocsigenserver \
	    --ocsigen-user ocsigen \
	    --ocsigen-group ocsigen \
	    $(OPT_CONFFLAGS)

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) $(BUILD_TARGET)
ifeq ($(BUILD_DOC),yes)
	$(MAKE) doc
endif

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) $(INSTALL_TARGET) CHOWN=/bin/true OCSIGENUSER=root OCSIGENGROUP=root
	$(MAKE) logrotate
ifeq ($(BUILD_DOC),yes)
	$(MAKE) install.doc
endif

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing -X.sample

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	[ ! -f Makefile.config ] || $(MAKE) distclean

=== debian/watch ===
version=3
http://ocsigen.org/ocsigenserver/install .*/archive/(.*)\.tar\.gz

## ocsigenserver 2.7

=== src/baselib/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 	ipaddr \
 	${SERVER_SYNTAX} ## See ../../Makefile.options
 LIBS     := ${addprefix -package ,${PACKAGE}}
-OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
+OCAMLC   := $(OCAMLFIND) ocamlc ${BYTEDBG} ${THREAD}
 OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
 OCAMLDOC := $(OCAMLFIND) ocamldoc
 OCAMLDEP := $(OCAMLFIND) ocamldep

=== src/extensions/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 	${SERVER_SYNTAX} ## See ../../Makefile.options
 
 LIBS     := -I ../baselib -I ../http -I ../server ${addprefix -package ,${PACKAGE}}
-OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG}
+OCAMLC   := $(OCAMLFIND) ocamlc ${BYTEDBG}
 OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
 OCAMLDOC := $(OCAMLFIND) ocamldoc
 OCAMLDEP := $(OCAMLFIND) ocamldep

=== src/http/Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	${SERVER_SYNTAX} ## See ../../Makefile.options
 
 LIBS     := -I ../baselib ${addprefix -package ,${PACKAGE}}
-OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG}
+OCAMLC   := $(OCAMLFIND) ocamlc ${BYTEDBG}
 OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
 OCAMLDOC := $(OCAMLFIND) ocamldoc
 OCAMLDEP := $(OCAMLFIND) ocamldep

=== src/server/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 PACKAGE  := ${SERVER_PACKAGE} ${SERVER_SYNTAX} ## See ../../Makefile.options
 LIBS     := -I ../baselib -I ../http ${addprefix -package ,${PACKAGE}} -I .
-OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
+OCAMLC   := $(OCAMLFIND) ocamlc ${BYTEDBG} ${THREAD}
 OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
 OCAMLDOC := $(OCAMLFIND) ocamldoc
 OCAMLDEP := $(OCAMLFIND) ocamldep

=== debian/changelog ===
ocsigenserver (2.7-1build4) artful; urgency=medium

  * No-change rebuild against libcryptokit-ocaml-ij9u6

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 31 Aug 2017 04:47:47 +0000

ocsigenserver (2.7-1build3) artful; urgency=high

  * No change rebuild against ocaml 4.04.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 14 Jul 2017 22:58:28 +0100

ocsigenserver (2.7-1build2) zesty; urgency=medium

  * Rebuild against new OCaml ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 08 Jan 2017 22:59:33 +0100

ocsigenserver (2.7-1build1) zesty; urgency=medium

  * Rebuild against new OCaml ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Dec 2016 22:39:58 +0100

ocsigenserver (2.7-1) unstable; urgency=medium

  * New upstream release
  * Update Vcs-*
  * Bump Standards-Version to 3.9.8
  * Bump debhelper compat to 9

 -- Stéphane Glondu <glondu@debian.org>  Fri, 12 Aug 2016 17:16:49 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: ocsigenserver
 Section: ocaml
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
  Stéphane Glondu <glondu@debian.org>,
  Samuel Mimram <smimram@debian.org>,
  Nicolas Dandrimont <nicolas.dandrimont@crans.org>
 Build-Depends:
- debhelper (>= 8),
+ debhelper (>= 9),
  ocaml-nox (>= 4.01),
  camlp4 (>= 4.02~),
  ocaml-findlib (>= 1.4),
@@ -22,10 +23,10 @@
  libfindlib-ocaml-dev,
  libipaddr-ocaml-dev,
  dh-ocaml (>= 0.9.5~)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.8
 Homepage: http://ocsigen.org/ocsigenserver/
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocsigenserver.git
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocsigenserver.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocsigenserver.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocsigenserver.git
 
 Package: ocsigenserver
 Section: httpd

## ocsigenserver 2.16.0

=== src/extensions/Makefile ===
--- 
+++ 
@@ -3,17 +3,17 @@
 PACKAGE  :=		\
 	bytes		\
 	lwt.unix	\
+	lwt_log		\
 	ipaddr		\
-	lwt.ssl		\
-	lwt.react	\
+	lwt_ssl		\
+	lwt_react	\
 	netstring	\
 	netstring-pcre	\
-	tyxml.parser	\
-	${SERVER_SYNTAX} ## See ../../Makefile.options
+	xml-light
 
 LIBS     := -I ../baselib -I ../http -I ../server ${addprefix -package ,${PACKAGE}}
-OCAMLC   := $(OCAMLFIND) ocamlc ${BYTEDBG}
-OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
+OCAMLC   := $(OCAMLFIND) ocamlc ${BYTEDBG} ${THREAD}
+OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
 OCAMLDOC := $(OCAMLFIND) ocamldoc
 OCAMLDEP := $(OCAMLFIND) ocamldep
 
@@ -46,6 +46,14 @@
 opt:: ${FILES:.ml=.cmxs}
 endif
 
+### PostgreSQL ###
+
+ifeq "$(OCSIPERSISTPGSQL)" "YES"
+byte::
+	$(MAKE) -C ocsipersist-pgsql byte
+opt::
+	$(MAKE) -C ocsipersist-pgsql opt
+endif
 ### SQLite ###
 
 ifeq "$(OCSIPERSISTSQLITE)" "YES"
@@ -80,6 +88,7 @@
 clean: clean.local
 	${MAKE} -C ocsipersist-dbm clean
 	${MAKE} -C ocsipersist-sqlite clean
+	${MAKE} -C ocsipersist-pgsql clean
 clean.local:
 	-rm -f *.cm* *.o *.a *.annot
 	-rm -f ${PREDEP}
@@ -87,6 +96,8 @@
 	-rm -f *~ \#* .\#*
 	${MAKE} -C ocsipersist-dbm distclean
 	${MAKE} -C ocsipersist-sqlite distclean
+	${MAKE} -C ocsipersist-pgsql distclean
+	-rm -f .depend
 
 ## Dependencies
 
@@ -94,6 +105,7 @@
 	$(OCAMLDEP) ${LIBS} *.mli *.ml > .depend
 	${MAKE} -C ocsipersist-dbm depend
 	${MAKE} -C ocsipersist-sqlite depend
+	${MAKE} -C ocsipersist-pgsql depend
 
 FORCE:
 -include .depend

=== src/http/Makefile ===
--- 
+++ 
@@ -3,13 +3,13 @@
 	bytes \
 	netstring \
 	netstring-pcre \
-	lwt.ssl \
-	tyxml \
-	${SERVER_SYNTAX} ## See ../../Makefile.options
+	lwt_ssl \
+	lwt_log \
+	tyxml
 
 LIBS     := -I ../baselib ${addprefix -package ,${PACKAGE}}
-OCAMLC   := $(OCAMLFIND) ocamlc ${BYTEDBG}
-OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
+OCAMLC   := $(OCAMLFIND) ocamlc ${BYTEDBG} ${THREAD}
+OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
 OCAMLDOC := $(OCAMLFIND) ocamldoc
 OCAMLDEP := $(OCAMLFIND) ocamldep

=== src/extensions/ocsipersist-dbm/Makefile ===
--- 
+++ 
@@ -1,9 +1,6 @@
 include ../../../Makefile.config
 
-PACKAGE  := ${LWT_PREEMPTIVE_PACKAGE} \
-	    lwt.unix     \
-	    tyxml.parser \
-	    dbm          \
+PACKAGE  := lwt.unix lwt_log xml-light dbm
 
 LIBS     := -I ../../baselib -I ../../http -I ../../server \
 	    ${addprefix -package ,${PACKAGE}}
@@ -39,7 +36,7 @@
 	cp $@ ..
 
 ocsipersist.mli:
-	ln -s ../ocsipersist.mli .
+	ln -s -f ../ocsipersist.mli .
 
 ###
 
@@ -71,6 +68,7 @@
 	-rm -f ocsidbm ocsidbm.opt
 distclean: clean
 	-rm -f *~ \#* .\#*
+	-rm -f .depend
 
 ## Dependencies

=== src/extensions/ocsipersist-pgsql/Makefile ===
include ../../../Makefile.config

PACKAGE  := xml-light pgocaml lwt lwt_log

LIBS     := -I ../../baselib -I ../../http -I ../../server \
	    ${addprefix -package ,${PACKAGE}}
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte opt

###

byte: ocsipersist-pgsql.cma
opt:: ocsipersist-pgsql.cmxa
ifeq "$(NATDYNLINK)" "YES"
opt:: ocsipersist-pgsql.cmxs
endif

PREDEP := ocsipersist.mli

ocsipersist-pgsql.cma: ocsipersist.cmo
	$(OCAMLC) -a -o $@ $^
	cp ocsipersist.cmi ..
	cp $@ ..

ocsipersist-pgsql.cmxa: ocsipersist.cmx
	$(OCAMLOPT) -a -o $@ $^
	cp ocsipersist.cmi ..
	cp $@ ${patsubst %.cmxa,%.a,$@} ..

ocsipersist-pgsql.cmxs: ocsipersist-pgsql.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $^
	cp $@ ..

ocsipersist.mli:
	ln -s -f ../ocsipersist.mli .

##########

%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) ${LIBS} -c $<
%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f ${PREDEP}
distclean: clean
	-rm -f *~ \#* .\#*
	-rm -f .depend

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} *.mli *.ml > .depend

FORCE:
-include .depend

=== src/extensions/ocsipersist-sqlite/Makefile ===
--- 
+++ 
@@ -1,8 +1,6 @@
 include ../../../Makefile.config
 
-PACKAGE  := lwt.preemptive  \
-	    tyxml.parser \
-	    sqlite3      \
+PACKAGE  := lwt lwt_log xml-light sqlite3
 
 LIBS     := -I ../../baselib -I ../../http -I ../../server \
 	    ${addprefix -package ,${PACKAGE}}
@@ -38,7 +36,7 @@
 	cp $@ ..
 
 ocsipersist.mli:
-	ln -s ../ocsipersist.mli .
+	ln -s -f ../ocsipersist.mli .
 
 ##########
 
@@ -58,6 +56,7 @@
 	-rm -f ${PREDEP}
 distclean: clean
 	-rm -f *~ \#* .\#*
+	-rm -f .depend
 
 ## Dependencies

=== debian/changelog ===
ocsigenserver (2.16.0-3build2) groovy; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Sep 2020 14:03:54 +0200

ocsigenserver (2.16.0-3build1) groovy; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 15 Aug 2020 19:55:21 +0200

ocsigenserver (2.16.0-3) unstable; urgency=medium

  * Add missing space in ocamlc invocation (Closes: #963461)
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0

 -- Stéphane Glondu <glondu@debian.org>  Tue, 04 Aug 2020 12:48:11 +0200

ocsigenserver (2.16.0-2) unstable; urgency=medium

  * Fix FTBFS on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Fri, 24 Jan 2020 13:49:24 +0100

ocsigenserver (2.16.0-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * New upstream release
  * Update Vcs-*
  * Bump debhelper compat level to 12
  * Bump Standards-Version to 4.4.1
  * Add Rules-Requires-Root: no
  * Remove Samuel from Uploaders

  [ Nicolas Dandrimont ]
  * d/control: remove myself from Uploaders

 -- Stéphane Glondu <glondu@debian.org>  Fri, 24 Jan 2020 11:03:53 +0100

=== debian/control ===
--- 
+++ 
@@ -1,36 +1,35 @@
 Source: ocsigenserver
 Section: ocaml
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
- Stéphane Glondu <glondu@debian.org>,
- Samuel Mimram <smimram@debian.org>,
- Nicolas Dandrimont <nicolas.dandrimont@crans.org>
+ Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper (>= 9),
- ocaml-nox (>= 4.01),
- camlp4 (>= 4.02~),
- ocaml-findlib (>= 1.4),
- liblwt-ssl-ocaml-dev (>= 2.5~),
- libocamlnet-ocaml-dev (>= 3.6.5),
- libpcre-ocaml-dev (>= 6.0.1-2~),
- libssl-ocaml-dev (>= 0.4.3-3~),
- libsqlite3-ocaml-dev (>= 1.5.6-3~),
- libzip-ocaml-dev (>= 1.04-6~),
- libcryptokit-ocaml-dev (>= 1.3-14~),
- libtyxml-ocaml-dev (>= 3.5.0~),
+ debhelper-compat (= 13),
+ ocaml-nox,
+ ocaml-findlib,
+ liblwt-ocaml-dev (>= 3.0.0),
+ liblwt-ssl-ocaml-dev,
+ liblwt-log-ocaml-dev,
+ libocamlnet-ocaml-dev,
+ libpcre-ocaml-dev,
+ libsqlite3-ocaml-dev,
+ libcryptokit-ocaml-dev,
+ libtyxml-ocaml-dev,
  libfindlib-ocaml-dev,
  libipaddr-ocaml-dev,
- dh-ocaml (>= 0.9.5~)
-Standards-Version: 3.9.8
+ libxml-light-ocaml-dev,
+ dh-ocaml
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: http://ocsigen.org/ocsigenserver/
-Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocsigenserver.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocsigenserver.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/ocsigenserver
+Vcs-Git: https://salsa.debian.org/ocaml-team/ocsigenserver.git
 
 Package: ocsigenserver
 Section: httpd
 Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
 Depends: adduser, psmisc, procps,
  ${ocaml:Depends},
  ${shlibs:Depends},

=== debian/rules ===
--- 
+++ 
@@ -46,6 +46,7 @@
 
 .PHONY: override_dh_auto_build
 override_dh_auto_build:
+	$(MAKE) depend
 	$(MAKE) $(BUILD_TARGET)
 ifeq ($(BUILD_DOC),yes)
 	$(MAKE) doc
@@ -59,10 +60,12 @@
 	$(MAKE) install.doc
 endif
 
-.PHONY: override_dh_install
-override_dh_install:
-	dh_install --fail-missing -X.sample
+.PHONY: override_dh_missing
+override_dh_missing:
+	dh_missing --fail-missing -X.sample
 
 .PHONY: override_dh_auto_clean
 override_dh_auto_clean:
 	[ ! -f Makefile.config ] || $(MAKE) distclean
+
+override_dh_dwz:
